Attribute VB_Name = "PhCommon22"

Option Explicit
   
   ' =======================================================================
   ' WORK IN PROGRESS !!!     *** Contains ERRORS ***
   '
   ' Translation from Phidget22.h C++ code, to Visual Basic 6 code.
   '
   ' Most function comments contain the orginal Phidget22 C++ code.
   '
   ' =======================================================================
   ' $=STRING    %=INTEGER int16    &=LONG int32    !=SINGLE flo32
   ' #=DOUBLE flo64   @=Currency 64bit +/-922,337,203,685,477.5807 fixed "."
   ' =======================================================================
   '    VB Type      C++ Type
   '    --------------------------
   '    Byte         unsigned char
   '    Integer%     short
   '    Long&        long
   '    Single!      float
   '    Double#      double
   '    Currency@    __int64
   ' =============================
   
   ' =========================================================================
   Public Declare Sub Sleep _
      Lib "kernel32" ( _
      ByVal dwMilliseconds&)
   
   Public Declare Function StrLen& _
      Lib "kernel32.dll" _
      Alias "lstrlenA" ( _
      ByVal strPtr&)

   Public Declare Function SysAllocStringByteLen$ _
      Lib "oleaut32.dll" ( _
      Optional ByVal pszStrPtr&, _
      Optional ByVal strLength&)

'===========================================================================
' PHIDGET COMMON MODULE FUNCTIONS
'===========================================================================
   
'===========================================================================
'/* Methods */
'===========================================================================

   ' =======================================================================
   ' Opens a Phidget.
   ' phid - A phidget handle.
   ' Phidget_open (PhidgetHandle phid);
   Public Declare Function PhOpen& _
      Lib "Phidget22.dll" _
      Alias "Phidget_open" ( _
      ByVal handle&)

   ' =======================================================================
   ' NOT WORKING
   ' Phidget_openWaitForAttachment (PhidgetHandle phid, uint32_t timeoutMs);
   Public Declare Function PhOpenWaitForAttachment& _
      Lib "Phidget22.dll" _
      Alias "Phidget_openWaitForAttachment" ( _
      ByVal handle&, _
      ByVal timeOutMs&)

   ' =======================================================================
   ' Closes a Phidget.
   ' phid - An opened phidget handle.
   ' Phidget_close (PhidgetHandle phid);
   Public Declare Function PhClose& _
      Lib "Phidget22.dll" _
      Alias "Phidget_close" ( _
      ByVal handle&)

   ' =======================================================================
   ' Frees a Phidget handle.
   ' phid - A closed phidget handle.
   ' Phidget_delete (PhidgetHandle *phid);
   Public Declare Function PhDelete& _
      Lib "Phidget22.dll" _
      Alias "Phidget_delete" ( _
      ByRef handle&)

   ' =======================================================================
   ' Example:  retVal& = PhWriteDeviceLabel&(handle&, StrPtr(deviceLabel$))
   ' Sets the label of a Phidget. Note that this is not suphubPorted on
   '    very old Phidgets, and not suphubPorted in Windows7.
   ' phid - An attached phidget handle.
   ' deviceLabel - A string containing the label to be set.
   ' Phidget_writeDeviceLabel (PhidgetHandle phid, const char *deviceLabel);
   Public Declare Function PhWriteDeviceLabel& _
      Lib "Phidget22.dll" _
      Alias "Phidget_writeDeviceLabel" ( _
      ByVal handle&, _
      ByRef Label$)

   ' =======================================================================
   ' Phidget_retain (
   '     PhidgetHandle phid);
   Public Declare Function PhRetain& _
      Lib "Phidget22.dll" _
      Alias "Phidget_retain" ( _
      ByVal handle&)

   ' =======================================================================
   ' Phidget_release (
   '     PhidgetHandle *phid);
   Public Declare Function PhRelease& _
      Lib "Phidget22.dll" _
      Alias "Phidget_release" ( _
      ByRef handle&)

   ' =======================================================================
   ' Phidget_getChildDevices (
   '     PhidgetHandle phid,
   '     PhidgetHandle *arr,
   '     size_t *arrCnt);
   Public Declare Function PhGetChildDevices& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getChildDevices" ( _
      ByVal handle&, _
      ByRef arr&, _
      ByRef arrCnt&)

   ' =======================================================================
   ' Phidget_releaseDevices (
   '     PhidgetHandle *arr,
   '     size_t arrCnt);
   Public Declare Function PhReleaseDevices& _
      Lib "Phidget22.dll" _
      Alias "Phidget_releaseDevices" ( _
      ByRef arr&, _
      ByVal arrCnt&)

   ' =======================================================================
   ' Phidget_getDataInterval (
   '     PhidgetHandle phid,
   '     uint32_t *di);
   Public Declare Function PhGetDataInterval& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDataInterval" ( _
      ByVal handle&, _
      ByRef di&)

   ' =======================================================================
   ' Phidget_setDataInterval (
   '     PhidgetHandle phid,
   '     uint32_t di);
   Public Declare Function PhSetDataInterval& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setDataInterval" ( _
      ByVal handle&, _
      ByVal di&)



'===========================================================================
'/* General Properties */
'===========================================================================

   ' =======================================================================
   ' Phidget_getAttached (
   '     PhidgetHandle phid,
   '     int *attached);
   Public Declare Function PhGetAttached& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getAttached" ( _
      ByVal handle&, _
      ByRef attached&)

   ' =======================================================================
   ' Phidget_getIsChannel (
   '     PhidgetHandle phid,
   '     int *isChannel);
   Public Declare Function PhGetIsChannel& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getIsChannel" ( _
      ByVal handle&, _
      ByRef isChannel&)

   ' =======================================================================
   ' Phidget_getIsLocal (
   '     PhidgetHandle phid,
   '     int *isLocal);
   Public Declare Function PhGetIsLocal& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getIsLocal" ( _
      ByVal handle&, _
      ByRef isLocal&)

   ' =======================================================================
   ' Phidget_setIsLocal (
   '     PhidgetHandle phid,
   '     int isLocal);
   Public Declare Function PhSetIsLocal& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setIsLocal" ( _
      ByVal handle&, _
      ByVal isLocal&)

   ' =======================================================================
   ' Phidget_getIsRemote (
   '     PhidgetHandle phid,
   '     int *isRemote);
   Public Declare Function PhGetIsRemote& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getIsRemote" ( _
      ByVal handle&, _
      ByRef isRemote&)

   ' =======================================================================
   ' Phidget_setIsRemote (
   '     PhidgetHandle phid,
   '     int isRemote);
   Public Declare Function PhSetisRemote& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setIsRemote" ( _
      ByVal handle&, _
      ByVal isRemote&)

   ' =======================================================================
   ' Phidget_getParent (
   '     PhidgetHandle phid,
   '     PhidgetHandle *parent);
   Public Declare Function PhGetParent& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getParent" ( _
      ByVal handle&, _
      ByRef parent&)

   ' =======================================================================
   ' Phidget_getServerName (
   '     PhidgetHandle phid,
   '     const char **serverName);
   Public Declare Function PhGetServerName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getServerName" ( _
      ByVal handle&, _
      ByRef serverNameStrPtr&)

   ' =======================================================================
   ' Phidget_setServerName (
   '     PhidgetHandle phid,
   '     const char *serverName);
   Public Declare Function PhSetServerName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setServerName" ( _
      ByVal handle&, _
      ByRef serverName$)

   ' =======================================================================
   ' Phidget_getServerPeerName (
   '     PhidgetHandle phid,
   '     const char **serverPeerName);
   Public Declare Function PhGetServerPeerName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getServerPeerName" ( _
      ByVal handle&, _
      ByRef serverPeerNameStrPtr&)

   ' =======================================================================
   ' Phidget_getServerHostname (
   '     PhidgetHandle phid,
   '     const char **serverHostname);
   Public Declare Function PhGetServerHostname& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getServerHostname" ( _
      ByVal handle&, _
      ByRef serverHostnameStrPtr&)




'===========================================================================
'/* Channel Properties */
'===========================================================================

   ' =======================================================================
   ' Phidget_getChannel (
   '     PhidgetHandle phid,
   '     int *channel);
   Public Declare Function PhGetChannel& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getChannel" ( _
      ByVal handle&, _
      ByRef channel&)

   ' =======================================================================
   ' Phidget_setChannel (
   '     PhidgetHandle phid,
   '     int channel);
   Public Declare Function PhSetChannel& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setChannel" ( _
      ByVal handle&, _
      ByVal channel&)

   ' =======================================================================
   ' Phidget_getChannelClass (
   '     PhidgetHandle phid,
   '     Phidget_ChannelClass *channelClass);
   Public Declare Function PhGetChannelClass& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getChannelClass" ( _
      ByVal handle&, _
      ByRef channelClass&)

   ' =======================================================================
   ' Phidget_getChannelClassName (
   '     PhidgetHandle phid,
   '     const char **channelClassName);
   Public Declare Function PhGetChannelClassName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getChannelClassName" ( _
      ByVal handle&, _
      ByRef serverHostnameStrPtr&)

   ' =======================================================================
   ' Phidget_getChannelName (
   '     PhidgetHandle phid,
   '     const char **channelName);
   Public Declare Function PhGetChannelName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getChannelName" ( _
      ByVal handle&, _
      ByRef channelNameStrPtr&)

   ' =======================================================================
   ' Phidget_getChannelSubclass (
   '     PhidgetHandle phid,
   '     Phidget_ChannelSubclass *channelSubclass);
   Public Declare Function PhGetChannelSubclass& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getChannelSubclass" ( _
      ByVal handle&, _
      ByRef channelSubclass&)




'===========================================================================
'/* Device Properties */
'===========================================================================

   ' =======================================================================
   ' Gets the class of a Phidget Handle.
   ' phid - A phidget handle.
   ' deviceClass - Pointer to the device class address.
   '
   ' Phidget_getDeviceClass (
   '     PhidgetHandle phid,
   '     Phidget_DeviceClass *deviceClass);
   Public Declare Function PhGetDeviceClass& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceClass" ( _
      ByVal handle&, _
      ByRef deviceClass&)

   ' =======================================================================
   ' Phidget_getDeviceClassName (
   '     PhidgetHandle phid,
   '     const char **deviceClassName);
   Public Declare Function PhGetDeviceClassName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceClassName" ( _
      ByVal handle&, _
      ByRef deviceClassNameStrPtr&)

   ' =======================================================================
   ' Gets the device ID of a Phidget.
   ' phid - An attached phidget handle.
   ' deviceID - Pointer to the device ID address.
   '
   ' Phidget_getDeviceID (
   '     PhidgetHandle phid,
   '     Phidget_DeviceID *deviceID);
   Public Declare Function PhGetDeviceID& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceID" ( _
      ByVal handle&, _
      ByRef deviceId&)

   ' =======================================================================
   ' Phidget_getDeviceLabel (
   '     PhidgetHandle phid,
   '     const char **deviceLabel);
   Public Declare Function PhGetDeviceLabel& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceLabel" ( _
      ByVal handle&, _
      ByRef deviceLabelStrPtr&)

   ' =======================================================================
   ' Example:  retVal& = PhSetDeviceLabel&(handle&, StrPtr(deviceLabel$))
   ' Sets the label of a Phidget. Note that this is nut suphubPorted on
   '    very old Phidgets, and not yet suphubPorted in Windows.
   ' phid - An attached phidget handle.
   ' deviceLabel - A string containing the label to be set.
   '
   ' Phidget_setDeviceLabel (
   '     PhidgetHandle phid,
   '     const char *deviceLabel);
   Public Declare Function PhSetDeviceLabel& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setDeviceLabel" ( _
      ByVal handle&, _
      ByRef deviceLabel$)

   ' =======================================================================
   ' Phidget_getDeviceName (
   '     PhidgetHandle phid,
   '     const char **deviceName);
   Public Declare Function PhGetDeviceName& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceName" ( _
      ByVal handle&, _
      ByRef deviceNameStrPtr&)

   ' =======================================================================
   ' Phidget_getDeviceSerialNumber (
   '     PhidgetHandle phid,
   '     int32_t *deviceSerialNumber);
   Public Declare Function PhGetDeviceSerialNumber& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceSerialNumber" ( _
      ByVal handle&, _
      ByRef deviceSerialNumber&)

   ' =======================================================================
   ' Phidget_setDeviceSerialNumber (
   '     PhidgetHandle phid,
   '     int32_t deviceSerialNumber);
   Public Declare Function PhSetDeviceSerialNumber& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setDeviceSerialNumber" ( _
      ByVal handle&, _
      ByVal deviceSerialNumber&)

   ' =======================================================================
   ' Phidget_getDeviceSKU (
   '     PhidgetHandle phid,
   '     const char **deviceSKU);
   Public Declare Function PhGetDeviceSKU& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceSKU" ( _
      ByVal handle&, _
      ByRef deviceSkuStrPtr&)

   ' =======================================================================
   ' Gets the firmware version of a Phidget.
   ' phid - An attached phidget handle.
   ' deviceVersion - An int pointer for returning the device version.
   '
   ' Phidget_getDeviceVersion (
   '     PhidgetHandle phid,
   '     int *deviceVersion);
   Public Declare Function PhGetDeviceVersion& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceVersion" ( _
      ByVal handle&, _
      ByRef deviceVersion&)

   ' =======================================================================
   ' Phidget_getDeviceChannelCount (
   '     PhidgetHandle phid,
   '     Phidget_ChannelClass cls,
   '     uint32_t *count);
   Public Declare Function PhGetDeviceChannelCount& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getDeviceChannelCount" ( _
      ByVal handle&, _
      ByRef count&)




'===========================================================================
'/* VINT Hub Properties */
'===========================================================================

   ' =======================================================================
   ' Phidget_getIsHubPortDevice (
   '     PhidgetHandle phid,
   '     int *isHubPortDevice);
   Public Declare Function PhGetIsHubPortDevice& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getIsHubPortDevice" ( _
      ByVal handle&, _
      ByRef isHubPortDevice&)

   ' =======================================================================
   ' Phidget_setIsHubPortDevice (
   '     PhidgetHandle phid,
   '     int isHubPortDevice);
   Public Declare Function PhSetIsHubPortDevice& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setIsHubPortDevice" ( _
      ByVal handle&, _
      ByVal isHubPortDevice&)

   ' =======================================================================
   ' Phidget_getHub (
   '     PhidgetHandle phid,
   '     PhidgetHandle *hub);
   Public Declare Function PhGetHub& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getHub" ( _
      ByVal handle&, _
      ByRef hubNbr&)

   ' =======================================================================
   ' Phidget_getHubPort (
   '     PhidgetHandle phid,
   '     int *hubPort);
   Public Declare Function PhGetHubPort& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getHubPort" ( _
      ByVal handle&, _
      ByRef port&)

   ' =======================================================================
   ' Phidget_setHubPort (
   '     PhidgetHandle phid,
   '     int hubPort);
   Public Declare Function PhSetHubPort& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setHubPort" ( _
      ByVal handle&, _
      ByVal port&)

   ' =======================================================================
   ' Phidget_getHubPortCount (
   '     PhidgetHandle phid,
   '     int *hubPortCount);
   Public Declare Function PhGetHubPortCount& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getHubPortCount" ( _
      ByVal handle&, _
      ByRef hubPortCount&)



'===========================================================================
'/* Mesh device properties */
'===========================================================================
   ' =======================================================================
   ' Phidget_setMeshMode (
   '     PhidgetHandle phid,
   '     Phidget_MeshMode mode);
   Public Declare Function PhSetMeshMode& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setMeshMode" ( _
      ByVal handle&, _
      ByVal mode&)

   ' =======================================================================
   ' Phidget_getMeshMode (
   '     PhidgetHandle phid,
   '     Phidget_MeshMode *mode);
   Public Declare Function PhGetMeshMode& _
      Lib "Phidget22.dll" _
      Alias "Phidget_getMeshMode" ( _
      ByVal handle&, _
      ByRef mode&)


'===========================================================================
'/* Events */
'===========================================================================

   ' =======================================================================
   ' Sets an attach handler callback function.
   '    This is called when this Phidget is plugged into the
   '    system, and is ready for use.
   ' phid - A phidget handle.
   ' fPtr - Callback function pointer.
   ' userPtr - A pointer for use by the user -
   '    this value is passed back into the callback function.

   ' Phidget_setOnAttachHandler (
   '     PhidgetHandle phid,
   '     PhOnAttachCallback fPtr,
   '     void *ctx);

   Public Declare Function PhSetOnAttach& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setOnAttachHandler" ( _
      ByVal handle&, _
      ByVal PhOnAttachCallbackPtr&, _
      ByRef userData&)
    
   ' =======================================================================
   ' Sets a detach handler callback function.
   '    This is called when this Phidget is unplugged from the system.
   ' phid-  A phidget handle.
   ' fPtr - Callback function pointer.
   ' userPtr - A pointer for use by the user -
   '    This value is passed back into the callback function.

   ' Phidget_setOnDetachHandler (
   '     PhidgetHandle phid,
   '     Phidget_OnDetachCallback fPtr,
   '     void *ctx);

   Public Declare Function PhSetOnDetach& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setOnDetachHandler" ( _
      ByVal handle&, _
      ByVal PhOnDetachCallbackPtr&, _
      ByRef userData&)
  
   ' =======================================================================
   ' Sets the error handler callback function that is called
   ' when an asynchronous error occurs.
   ' phid - A phidget handle.
   ' fPtr - Callback function pointer.
   ' userPtr - A pointer for use by the user -
   '    this value is passed back into the callback function.
   
   ' Phidget_setOnErrorHandler (
   '     PhidgetHandle phid,
   '     PhOnErrorCallback fPtr,
   '     void *ctx);
   
   Public Declare Function PhSetOnError& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setOnErrorHandler" ( _
      ByVal handle&, _
      ByVal PhOnErrorCallbackPtr&, _
      ByRef userData&)

   ' =======================================================================
   ' Phidget_setOnPropertyChangeHandler(
   '     PhidgetHandle phid,
   '     Phidget_OnPropertyChangeCallback fPtr,
   '     void *ctx);

   'Type PhOnPropertyChangeCallback
   '   phid As Long
   '   ctxPtr As Long
   '   prpty As String
   'End Type

   Public Declare Function PhSetOnPropertyChangeHandler& _
      Lib "Phidget22.dll" _
      Alias "Phidget_setOnPropertyChangeHandler" ( _
      ByVal handle&, _
      ByVal PhOnPropertyChangeCallbackPtr&, _
      ByRef userData&)


'===========================================================================
'/* Library Methods */
'===========================================================================

   ' =======================================================================
   ' Phidget_finalize (
   '      int flags);          ' Informational flags
   Public Declare Function PhFinalize& _
      Lib "Phidget22.dll" _
      Alias "Phidget_finalize" ( _
      ByVal flags&)

   ' =======================================================================
   ' Gets the description for an error code.
   ' errorCode - The error code to get the description of.
   ' errorString - A pointer which will be set to a char array
   '               containing the error description string.
   ' Phidget_getErrorDescription (
   '     PhidgetReturnCode errorCode,
   '     const char **errorString);
   Public Declare Function Phidget_getErrorDescription& _
      Lib "Phidget22.dll" ( _
      ByVal errCode&, _
      ByRef errStringStrPtr&)

   ' NOTE: Do not use this function.
   ' To get the error String from the error Code
   ' USE: errStr$ = PhGetErrorDescription&(errCode&)

'===========================================================================
Public Static Function PhGetErrorDescription$(errCode&)
   ' Example:  errStr$ = PhGetErrorDescription&(errCode&)
   '
   ' Required for returning string data from the Phidget22 DLL.
   ' VB6 expects string data to be returned ByRef.  Which is a
   ' pointer to the actual string.  The Phidget22 DLL returns
   ' a pointer to a pointer which points to the actual data.
   ' The string is also NULL (0) terminated.  The "0" must be
   ' removed before VB can display the string correctly.
   ' Fortunately; There is an API function that takes care of
   ' all of this for us. "SysAllocStringByteLen"

   Dim retVal&
   Dim cStrPtr&
   
   PhGetErrorDescription$ = "" ' Return with nothing if error
   retVal& = Phidget_getErrorDescription&(errCode&, cStrPtr&) ' Get cStrPtr&
   If retVal& = 0 Then
      ' Got pointer to string, now get string
      PhGetErrorDescription$ = SysAllocStringByteLen$(cStrPtr&, StrLen&(cStrPtr&))
   End If
   
End Function



